From 43232b9effde329dbfae09316495ddbafd458253 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 04 2020 03:54:14 +0000
Subject: [PATCH 953/2232] Add trait bound to ExternType::Kind


---

diff --git a/src/extern_type.rs b/src/extern_type.rs
index ab7b3fd..b984f55 100644
--- a/src/extern_type.rs
+++ b/src/extern_type.rs
@@ -1,3 +1,5 @@
+use self::kind::Kind;
+
 /// A type for which the layout is determined by its C++ definition.
 ///
 /// This trait serves the following two related purposes.
@@ -135,7 +137,7 @@ pub unsafe trait ExternType {
     /// by value, and include it in `struct`s that you have declared to
     /// `cxx::bridge`. Your claim about the triviality of the C++ type will be
     /// checked by a `static_assert` in the generated C++ side of the binding.
-    type Kind;
+    type Kind: Kind;
 }
 
 /// Marker types identifying Rust's knowledge about an extern C++ type.
@@ -160,6 +162,10 @@ pub mod kind {
     /// therefore be owned and moved around in Rust code without requiring
     /// indirection.
     pub enum Trivial {}
+
+    pub trait Kind {}
+    impl Kind for Opaque {}
+    impl Kind for Trivial {}
 }
 
 #[doc(hidden)]

